/***
 * Excerpted from "Using memcached: How to scale your website easily",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/memcd for more book information.
***/
using System;
using System.Collections.Generic;
using System.Text;

using Enyim.Caching;
using Enyim.Caching.Memcached;



namespace memcachedTestLRU
{
  class Program
  {
    static void Main(string[] args)
    {


      int loopTo = 50000;
      if (args != null)
      {
        try{loopTo = Convert.ToInt32 (args[0]);}
        finally{}
      }
      
      
      string Guid1 = Guid.NewGuid().ToString();
      string Guid2 = Guid.NewGuid().ToString();
      
      string Guid3 = Guid.NewGuid().ToString();
      string Guid4 = Guid.NewGuid().ToString();
      string Guid5 = Guid.NewGuid().ToString();
      
      Console.WriteLine("Loading {0}", Guid1);
      MemcachedClient mc = new MemcachedClient();
      mc.Remove(Guid1);
      mc.Store(StoreMode.Replace, Guid1, Guid1);
      
      Console.WriteLine("Loading {0}", Guid2);
      mc.Store(StoreMode.Set, Guid2, Guid2);
      Console.WriteLine("Loading {0}", Guid3);
      mc.Store(StoreMode.Set, Guid3, Guid3);
      Console.WriteLine("Loading {0}", Guid4);
      mc.Store(StoreMode.Set, Guid4, Guid4);
      Console.WriteLine("Loading {0}", Guid5);
      mc.Store(StoreMode.Set, Guid5, Guid5);
      
      Console.WriteLine("Filling cache");
      for (int i = 0; i < loopTo;i++ )
      {
        
        if ((i % 5) == 0)
          Console.Write("\b\b\b\b\b\b\b\b\b{0}", i);
        
        mc.Store(StoreMode.Add, Guid.NewGuid().ToString(), Guid.NewGuid().ToString());
        if ((i % 2) == 0)
          mc.Get(Guid1);
        
        if ((i % 5) == 0)
          mc.Get(Guid2);
        if ((i % 7) == 0)
          mc.Get(Guid3);
        
      }
      if (mc.Get(Guid1) == null)
        Console.WriteLine("Guid1 was deleted");
      
      else Console.WriteLine("Guid1 found");
      if (mc.Get(Guid2) == null)
        Console.WriteLine("Guid2 was deleted");
      else Console.WriteLine("Guid2 found");
      if (mc.Get(Guid3) == null)
        Console.WriteLine("Guid3 was deleted");
      else Console.WriteLine("Guid3 found");
      if (mc.Get(Guid4) == null)
        Console.WriteLine("Guid4 was deleted");
      else Console.WriteLine("Guid4 found");
      if (mc.Get(Guid5) == null)
        Console.WriteLine("Guid5 was deleted");
      else Console.WriteLine("Guid5 found");
      
      Console.WriteLine("\r\nPress any key to continue");
      Console.ReadKey();
    }
  }
}
