#!/usr/bin/perl
#---
# Excerpted from "Using memcached: How to scale your website easily",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/memcd for more book information.
#---
use strict;
use DBI;
use Cache::Memcached;
use Digest::SHA qw(sha512_base64);
use Time::HiRes qw( gettimeofday tv_interval usleep);

# Set the server list up
my $memd = new Cache::Memcached {'servers' => [ "127.0.0.1:11211"],};
$memd->set_compress_threshold(1_000);
$memd->enable_compress(1);

# DBI configuration
my $dsn = "DBI:mysql:memcachedTesting:localhost";
my $user = "mcd";	#Notice, not root
my $pw = "n0pass";	#Notice, password 
my $table = "";


#$table = &GetCalendarOfEvents(1);
#&UpdateCalendarOfEvents(1, "2008-01-01", "New Year's Day 2008", "Time to start anew!",1);
while(1>0)
{$table = &GetCalendarOfEvents(1);}
#print $table;



sub UpdateCalendarOfEvents
{
  my ($EventID, $EventDate, $Description, $Details, $WebSiteID) = @_;
  my $dbh = DBI->connect($dsn, $user, $pw);
  #update the database
  my $update_handle = $dbh->prepare_cached('UPDATE calendarofevents 
	set EventDate=?, Description=?, Details=?
	WHERE EventID=?');
  $update_handle->execute($EventDate, $Description, $Details, $EventID);
  
  #remove from memcached
  my $tableKey = sha512_base64("CalendarOfEvents:HTMLTable:".$WebSiteID);
  my $statement = "select EventID, EventDate, Description, Details ".
     "from calendarofevents where WebSiteID = ".$WebSiteID;
  my $dataKey = sha512_base64($statement);
  &GetCalendarOfEvents($WebSiteID,1);
}




sub GetCalendarOfEventsDB
{
  my $statement = shift;
  my $dbh = DBI->connect($dsn, $user, $pw);
  my $key_field = "EventID";
  my $lockKey = sha512_base64($statement.":lock");
  my $key = sha512_base64($statement);
  my $lockCount = 0;
  my $returnValue = "";
  while(1 > 0) {
    #Check to see if anyone else is attempting to get data
    if($memd->get($lockKey) && $lockCount < 3) #Someone is making the attempt
    {  $lockCount ++;
       usleep('500_000'); # sleep a half second
       if($memd->get($key)) #Can get from memcached
	{$returnValue = $memd->get($key);
	 print "got value from someone else stuffing it in memcached\n";
         last;}
    }
    else #we are going to make the attempt
    {
      $memd->set($lockKey, [gettimeofday]);
      $returnValue = $dbh->selectall_hashref($statement, $key_field);
      print "got data from database\nstoring in memcached:\n";
      $memd->set (sha512_base64($statement), $returnValue);
      $memd->delete($lockKey);
      last;
    }
  }  
  $returnValue;
}


sub GetCalendarOfEvents
{
  my $WebSiteID = shift;
  my $ForceOverRide = shift;
  my $statement = "select EventID, EventDate, Description, Details ".
     "from calendarofevents where WebSiteID = ".$WebSiteID;
  my $tableKey = sha512_base64("CalendarOfEvents:HTMLTable:".$WebSiteID);
  my $table = $memd->get($tableKey);	#Look for the HTML Table
  my $dataKey = sha512_base64($statement);
if (not $table or ($ForceOverRide)) {
  print "going to memcached for data object\n";
  my $data = $memd->get($dataKey);
  if (not $data or ($ForceOverRide)) { 
    # Check to see if another process is getting data
      print "going to database\n";
    $data = &GetCalendarOfEventsDB($statement);
  } #end not $data

  #Whether from memcached or from the database, I have a hashref to parse
  $table = "<table border=1>";
  while( my ($k, $v) = each %$data ) {
	$table = $table . "<tr><td>"
	.$v->{EventDate}."</td><td><a href=BookReservation.html?EventID="
	.$v->{EventID}.">".$v->{Description}."</a><br />"
	.$v->{Details}."</td></tr>\r\n"; 
  } #end while loop through %data
  $table = $table . "</table>";
  $memd->set($tableKey, $table);
 } #end not $table
$table;
}

