/***
 * Excerpted from "Using memcached: How to scale your website easily",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/memcd for more book information.
***/
using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using System.Data.SqlClient;

// MemCache
using Enyim.Caching;
using Enyim.Caching.Memcached;
using Enyim.Caching.Configuration;


namespace memcachedCalendarOfEvents_1
{
 class Program
 {
	static void Main(string[] args)
	{
	 
	 string xmlData = "";
	 MemcachedClient mc = new MemcachedClient();
	 DataSet ds = new DataSet();
	 object mcObject = mc.Get("CalendarOfEvents");
	 if (mcObject == null) // Connect to database and get data
	 {
		SqlConnection cn = new SqlConnection(Properties.Settings.Default.DatabaseConnection);
		SqlDataAdapter da = new SqlDataAdapter("SELECT EventID, EventDate, Description, Details from CalendarOfEvents where WebSiteID = 1", cn);
		cn.Open();
		da.Fill(ds);
		// Change to xml string
		System.IO.StringWriter sw = new System.IO.StringWriter();
		ds.WriteXml(sw);
		xmlData = sw.ToString();
		mc.Store(StoreMode.Set, "CalendarOfEvents", xmlData);
		cn.Close();
	 }
	 else
	 {
		xmlData = Convert.ToString(mcObject);
	 }
	 ds.ReadXml(new System.IO.StringReader(xmlData));
	 Console.WriteLine("<table border='1'><tr><th>EventDate</th><th>Details</th></tr>");
	 DataTable dt = ds.Tables[0];
	 foreach (DataRow dr in dt.Rows)
		Console.WriteLine("<tr><td>{0}</td><td><a href=BookReservation.html?EventID={1}>{0}</a><br />{2}</td></tr>", dr["Description"].ToString(),
		 dr["Description"].ToString(), dr["Details"].ToString());
	 Console.WriteLine("</table>");
	}
 }
}
