/***
 * Excerpted from "Using memcached: How to scale your website easily",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/memcd for more book information.
***/
using System;
using System.Collections.Generic;
using System.Text;


using System.Data;
using System.Data.SqlClient;

// MemCache
using Enyim.Caching;
using Enyim.Caching.Memcached;
using Enyim.Caching.Configuration;


namespace memcachedUpdateCalendarOfEvents_3
{
    class memcachedExample
    {
        MemcachedClient mc = new MemcachedClient();

        public void UpdateCalendarOfEvents(int EventID, string EventDate, string Description, string Details, int WebSiteID)
        {
            // Update the database
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = new SqlConnection(Properties.Settings.Default.DatabaseConnection);
            cmd.CommandText = string.Format("Update CalendarOfEvents set EventDate = '{0}', Description = '{1}', Details = '{2}', WebSiteID = {3} WHERE EventID = {4}",
               EventDate, Description.Replace("'", "''"), Details.Replace("'", "''"), WebSiteID, EventID);
            cmd.Connection.Open();
            cmd.ExecuteNonQuery();
            cmd.Connection.Close();
            // remove HTML table from memcached
            string tablekey = md5(string.Format("CalendarOfEvents:HTMLTable:{0}", WebSiteID));
            string statementKey = md5(string.Format("SELECT EventID, EventDate, Description, Details from CalendarOfEvents where WebSiteID = {0}", WebSiteID));
            
            mc.Remove(tablekey);
            mc.Remove(statementKey);
        }

        public string GetCalendarOfEvents(int WebSiteID)
        {
            return GetCalendarOfEvents(WebSiteID, false);
        }

        public string GetCalendarOfEventsDB(string SQLStatement, bool ForceOverRide)
        {
            string lockKey = md5(SQLStatement + ":lock");
            string key = md5(SQLStatement);
            int lockcount = 0;
            string retVal = "";
            while (true)
            {
                // See if anyone else is attempting to get the data
                if (mc.Get(lockKey) != null && lockcount++ < 3) // Someone else is trying so sleep
                {
                    System.Threading.Thread.Sleep(5000);
                    if (mc.Get(key) != null)
                    {
                        retVal = Convert.ToString(mc.Get(key));
                        Console.WriteLine("got value from someone else stuffing it in memcached");
                        break;
                    }
                }
                else // Either no one else is trying to get the data or we've waited through three locks
                {
                    mc.Store(StoreMode.Set, lockKey, System.DateTime.Now.ToLongDateString());
                    DataSet ds = new DataSet();
                    SqlConnection cn = new SqlConnection(Properties.Settings.Default.DatabaseConnection);
                    SqlDataAdapter da = new SqlDataAdapter(SQLStatement, cn);
                    cn.Open();
                    da.Fill(ds);
                    // Change to xml string
                    System.IO.StringWriter sw = new System.IO.StringWriter();
                    ds.WriteXml(sw);
                    retVal  = sw.ToString();
                    mc.Store(StoreMode.Set, "CalendarOfEvents", retVal);
                    cn.Close();
										mc.Remove(lockKey);
                    break;
                }
            }
            return retVal;
        }

        public string GetCalendarOfEvents(int WebSiteID, bool ForceOverRide)
        {
            string retTable = "";
            string xmlData = "";
            string sqlStatement = string.Format("SELECT EventID, EventDate, Description, Details from CalendarOfEvents where WebSiteID = {0}", WebSiteID);
            string tablekey = md5(string.Format("CalendarOfEvents:HTMLTable:{0}", WebSiteID));
            string statementKey = md5(sqlStatement);

            
            // Check memcached for html table
            object htmlTable = mc.Get(tablekey);
            if (htmlTable == null || ForceOverRide) // we need to create the table
            {
                DataSet ds = new DataSet();
                xmlData = GetCalendarOfEventsDB(string.Format ("SELECT EventID, EventDate, Description, Details from CalendarOfEvents where WebSiteID = {0}", WebSiteID), ForceOverRide);
                ds.ReadXml(new System.IO.StringReader(xmlData));

                StringBuilder sb = new StringBuilder("<table border='1'><tr><th>EventDate</th><th>Details</th></tr>");
                DataTable dt = ds.Tables[0];
                foreach (DataRow dr in dt.Rows)
                    sb.AppendFormat("<tr><td>{0}</td><td><a href=BookReservation.html?EventID={1}>{0}</a><br />{2}</td></tr>", dr["Description"].ToString(),
                       dr["Description"].ToString(), dr["Details"].ToString());
                sb.AppendFormat("</table>");

                retTable = sb.ToString();
                mc.Store(StoreMode.Set, tablekey, retTable);
            }
            else
            {
                retTable = Convert.ToString(htmlTable);
            }
            return retTable;
        }

        string md5(string data)
        {
            return Convert.ToBase64String(new System.Security.Cryptography.MD5CryptoServiceProvider().ComputeHash(System.Text.Encoding.Default.GetBytes(data)));
        }
    }
}
